/*
	ChoicesCmd.h - Mixwave global personality (system control)

	Will Eighteen, 2001: will@opaline.demon.co.uk
*/

#ifndef CHOICESCMD_H
#define CHOICESCMD_H

#include "NoUndoCmd.h"
#include <Xm/Xm.h>


class ChoicesCmd : public NoUndoCmd
{
	public:
		ChoicesCmd ( const char *, int active );
		~ChoicesCmd();
		virtual const char *const className() { return ( "ChoicesCmd" ); }
		
	protected:
		void doCommand();		// called by base class

	private:
		static void quitCallback ( Widget, XtPointer, XtPointer );
		static void linkViewsCallback ( Widget, XtPointer, XtPointer );
		static void syncLengthCallback ( Widget, XtPointer, XtPointer );
		static void messagesCallback ( Widget, XtPointer, XtPointer );
		static void warningsCallback ( Widget, XtPointer, XtPointer );
		static void saveCallback ( Widget, XtPointer, XtPointer );
		static void remixCallback ( Widget, XtPointer, XtPointer );
		static void mixToCurrentCallback ( Widget, XtPointer, XtPointer );
		static void syncSelectionsCallback ( Widget, XtPointer, XtPointer );
		
		// callback for WM 'X'
		static void clientMessageProc ( Widget, XtPointer, XmAnyCallbackStruct * );

		void quit();
		void linkViews ( XtPointer );
		void syncLength ( XtPointer );
		void syncSelections ( XtPointer );
		void messages ( XtPointer );
		void warnings ( XtPointer );
		void save ( XtPointer );
		void remix ( XtPointer );
		void mixToCurrent ( XtPointer );

		char _name[128];
		Boolean _popupRealised;
		Widget _popup, _rc, _quit, _mixToCurrent, _syncSelections;
		Widget _syncLength, _linkViews, _messages, _warnings, _save, _remix;
};

#endif
