/*
 ButtonInterface.h - pushbutton interface to a Cmd object

 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.
*/

#ifndef BUTTONINTERFACE_H
#define BUTTONINTERFACE_H

#include "CmdInterface.h"


class ButtonInterface : public CmdInterface
{
	public:
		ButtonInterface ( Widget, Cmd * );
};

#endif

/*
  Notes:
  
  The class defines only a constructor expecting a parent widget and a pointer to
  a Cmd object; all other facilities are inherited from CmdInterface.
  
  The constructor creates an XmPushButton widget and installs a callback to
  handle unexpected destruction, using the convenience function in Interface.

  Once the widget is created, its sensitivity is set according to _active        
  (initialized when the object is registered with a Cmd object). The constructor 
  finally installs the executeCallback() function, executing the associated Cmd
  object when the base widget is activated.
*/
