/*
 CmdList.h - maintain list of Cmd objects

 Douglas A. Young, 'Object-oriented Programming with C++ and OSF/Motif'
 2nd ed., Prentice-Hall.

 Modified by Will 18, 2006: will@opaline.demon.co.uk
 Added 'remove ( Cmd * )' to support RemoveFromUndoList in Cmd
*/

#ifndef CMDLIST_H
#define CMDLIST_H

#include "Cmd.h"
#include "List.h"


class CmdList : public Cmd
{
	public:
		CmdList ( const char *name = "mylist" ) : Cmd ( name ) {}
		virtual ~CmdList();
		
		virtual void execute();
		virtual void undo();
		virtual void revert();
		void add ( Cmd *cmd )  { _contents.Add ( cmd ); }
		void remove ( Cmd *cmd )  { _contents.Remove ( cmd ); }
		int size() { return ( _contents.Count() ); }	/* easier for subclasses */
		Cmd *operator[] ( int i ) { return _contents[i]; }
		virtual void activate();
		virtual void deactivate();
		virtual CmdType type() { return ( myList ); }
		
	protected:
		virtual void doCommand();
		virtual void undoCommand();
		List <Cmd*> _contents;
};

#endif
