/* OpResources.cc - support operational parameters for application  or class */
/* copyleft GPL; Will 18, 2000 - see COPYING for full details */

#include "OpResources.h"
#include <stdlib.h>
#include <sys/stat.h>

#define BUFSIZE 1024


OpResources::OpResources ( char *paramsFileName )
{
	struct stat statInfo;
	int error = 0;
	char file[256];
	char *opResFile;
	
	_error[0] = 0;
	_appResources.saveOnExit = 0;
	
	strncpy ( _fileName, paramsFileName, 63 );
	strcpy ( file, ( char * ) getenv("HOME"));
	strcat ( file, "/" );		
	strcat ( file, ( char * ) paramsFileName );
	opResFile = ( char * ) &file;
	strncpy ( _opResourceFile, opResFile, 255 ); /*store the resource file name */

	if ( ( _file = fopen ( opResFile, "r" ) ) == NULL )
	{
		printf("creating new resource file for %s\n", _fileName);
		initOpResources();
		setOpResources();
	}
	else
	{
		if ( stat ( opResFile, &statInfo ) == 0 )
			_fileSize = statInfo.st_size;

		if ( _fileSize == 0 )
		{
			printf ( _error, "%s is empty!", opResFile );
			fclose ( _file );
			opResFile = 0;
		}
		else
			getOpResources();
	}	
}


OpResources::~OpResources()
{
	if ( _appResources.saveOnExit )
		setOpResources();
}


void OpResources::initOpResources()
{	
	_appResources.saveOnExit = 0;	// false

 	/* user-definable structure contents */
	_appResources.myNum = 0;
	strncpy ( _appResources.myString, "my string",
				sizeof ( _appResources.myString ) );
}


void OpResources::setOpResources()
{
	if ( ( _file = fopen ( _opResourceFile, "w" ) ) == NULL )
		printf ( "Can't write resources %s", _opResourceFile );
	else
	{
		fwrite ( &_appResources, sizeof ( _appResources ), 1, _file );
		fclose ( _file );
	}
}


void OpResources::getOpResources()
{
	if ( ( _file = fopen ( _opResourceFile, "r" ) ) == NULL )
		sprintf ( _error, "Can't read resources %s", _opResourceFile );
	else
	{
		fread ( &_appResources, sizeof ( _appResources ), 1, _file );
		fclose ( _file );
	}
}


void OpResources::setSaveOnExit ( int status )
{
	if ( status != 0 )
		status = 1;
		
	_appResources.saveOnExit = status;
	setOpResources();
}


void OpResources::save()
{
    setOpResources();	// save immediate if resources are changed at runtime
}
